78cc6557e32c7f0ab9e8aadb89945abae16f93cf
[oota-llvm.git] / utils / buildit / build_llvm
1 #!/bin/sh
2 # LLVM LOCAL file B&I
3
4 set -x
5
6 # Build LLVM the "Apple way".
7 # Parameters:
8
9 # The first parameter is a space-separated list of the architectures the
10 # compilers will run on. For instance, "ppc i386". If the current machine
11 # isn't in the list, it will (effectively) be added.
12 HOSTS="$1"
13
14 # The second parameter is a space-separated list of the architectures the
15 # compilers will generate code for. If the current machine isn't in the list, a
16 # compiler for it will get built anyway, but won't be installed.
17 # FIXME: The list of targets is currently hard-coded and TARGETS is not used.
18 TARGETS="$2"
19
20 # The third parameter is the path to the compiler sources. There should be a
21 # shell script named 'configure' in this directory. This script makes a copy...
22 ORIG_SRC_DIR="$3"
23
24 # The fourth parameter is the location where the LLVM will be installed. You can
25 # move it once it's built, so this mostly controls the layout of $DEST_DIR.
26 DEST_ROOT="$4"
27
28 # The fifth parameter is the place where the compiler will be copied once it's
29 # built.
30 DEST_DIR="$5"
31
32 # The sixth parameter is a directory in which to place information (like
33 # unstripped executables and generated source files) helpful in debugging the
34 # resulting compiler.
35 SYM_DIR="$6"
36
37 # The seventh parameter is a yes/no that indicates whether assertions should be
38 # enabled in the LLVM libs/tools.
39 LLVM_ASSERTIONS="$7"
40
41 # The eighth parameter is a yes/no that indicates whether this is an optimized
42 # build.
43 LLVM_OPTIMIZED="$8"
44
45 # The ninth parameter is a yes/no that indicates whether libLTO.dylib
46 # should be installed.
47 INSTALL_LIBLTO="$9"
48
49 # The tenth parameter is the version number of the submission, e.g. 1007.
50 LLVM_SUBMIT_VERSION="${10}"
51
52 # The eleventh parameter is the subversion number of the submission, e.g. 03.
53 LLVM_SUBMIT_SUBVERSION="${11}"
54
55 # The current working directory is where the build will happen. It may already
56 # contain a partial result of an interrupted build, in which case this script
57 # will continue where it left off.
58 DIR=`pwd`
59
60 DARWIN_VERS=`uname -r | sed 's/\..*//'`
61 echo DARWIN_VERS = $DARWIN_VERS
62
63 DEVELOPER_DIR="${DEVELOPER_DIR-Developer}"
64 if [ "x$RC_ProjectName" = "xllvmCore_EmbeddedHosted" ]; then
65     DT_HOME="$DEST_DIR/usr"
66     HOST_SDKROOT=$SDKROOT
67 else
68     DT_HOME="$DEST_DIR/$DEVELOPER_DIR/usr"
69 fi
70
71 DEST_ROOT="/$DEVELOPER_DIR$DEST_ROOT"
72
73 ################################################################################
74 # Run the build.
75
76 # Create the source tree we'll actually use to build, deleting
77 # tcl since it doesn't actually build properly in a cross environment
78 # and we don't really need it.
79 SRC_DIR=$DIR/src
80 rm -rf $SRC_DIR || exit 1
81 mkdir $SRC_DIR || exit 1
82 ln -s $ORIG_SRC_DIR/* $SRC_DIR/ || exit 1
83 # We can't use the top-level Makefile as-is.  Remove the soft link:
84 rm $SRC_DIR/Makefile || exit 1
85 # Now create our own by editing the top-level Makefile, deleting every line marked "Apple-style":
86 sed -e '/[Aa]pple-style/d' -e '/include.*GNUmakefile/d' $ORIG_SRC_DIR/Makefile > $SRC_DIR/Makefile || exit 1
87
88 # Build the LLVM tree universal.
89 mkdir -p $DIR/obj-llvm || exit 1
90 cd $DIR/obj-llvm || exit 1
91
92
93 if [ "x$RC_ProjectName" = "xllvmCore_EmbeddedHosted" ]; then
94   # The cross-tools' build process expects to find an existing cross toolchain
95   # under names like 'arm-apple-darwin$DARWIN_VERS-as'; so make them.
96   rm -rf $DIR/bin || exit 1
97   mkdir $DIR/bin || exit 1
98   for prog in ar nm ranlib strip lipo ld as ; do
99     P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
100     T=`xcrun -sdk $SDKROOT -find ${prog}`
101     echo '#!/bin/sh' > $P || exit 1
102     echo 'exec '$T' "$@"' >> $P || exit 1
103     chmod a+x $P || exit 1
104   done
105   # Try to use the platform llvm-gcc. Fall back to gcc if it's not available.
106   for prog in gcc g++ ; do
107     P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
108     T=`xcrun -find llvm-${prog}`
109     if [ "x$T" = "x" ] ; then
110       T=`xcrun -sdk $SDKROOT -find ${prog}`
111     fi
112     echo '#!/bin/sh' > $P || exit 1
113     echo 'exec '$T' -arch armv6 -isysroot '${SDKROOT}' "$@"' >> $P || exit 1
114     chmod a+x $P || exit 1
115   done
116
117   PATH=$DIR/bin:$PATH
118 # otherwise, try to use llvm-gcc if it's available
119 elif [ $DARWIN_VERS -gt 9 ]; then
120   # If the user has set CC or CXX, respect their wishes.  If not,
121   # compile with LLVM-GCC/LLVM-G++ if available; if LLVM is not
122   # available, fall back to usual GCC/G++ default.
123   savedPATH=$PATH ; PATH="/Developer/usr/bin:$PATH"
124   XTMPCC=$(which llvm-gcc)
125   if [ x$CC  = x -a x$XTMPCC != x ] ; then export CC=$XTMPCC  ; fi
126   XTMPCC=$(which llvm-g++)
127   if [ x$CXX = x -a x$XTMPCC != x ] ; then export CXX=$XTMPCC ; fi
128   PATH=$savedPATH
129   unset XTMPCC savedPATH
130 fi
131
132
133 if [ "x$RC_ProjectName" = "xllvmCore_EmbeddedHosted" ]; then
134   if [ \! -f Makefile.config ]; then
135       $SRC_DIR/configure --prefix=$DT_HOME \
136           --enable-targets=arm \
137           --host=arm-apple-darwin10 \
138           --target=arm-apple-darwin10 \
139           --build=i686-apple-darwin10 \
140           --enable-assertions=$LLVM_ASSERTIONS \
141           --enable-optimized=$LLVM_OPTIMIZED \
142           --disable-bindings \
143           || exit 1
144   fi
145 else
146   if [ \! -f Makefile.config ]; then
147       $SRC_DIR/configure --prefix=$DT_HOME/local \
148           --enable-targets=arm,x86,powerpc,cbe \
149           --enable-assertions=$LLVM_ASSERTIONS \
150           --enable-optimized=$LLVM_OPTIMIZED \
151           --disable-bindings \
152           || exit 1
153   fi
154 fi
155
156 SUBVERSION=`echo $RC_ProjectSourceVersion | sed -e 's/[^.]*\.\([0-9]*\).*/\1/'`
157
158 if [ "x$SUBVERSION" != "x$RC_ProjectSourceVersion" ]; then
159     LLVM_SUBMIT_SUBVERSION=`printf "%02d" $SUBVERSION`
160     RC_ProjectSourceVersion=`echo $RC_ProjectSourceVersion | sed -e 's/\..*//'`
161     LLVM_SUBMIT_VERSION=$RC_ProjectSourceVersion
162 fi
163
164 if [ "x$LLVM_SUBMIT_SUBVERSION" = "x00" -o "x$LLVM_SUBMIT_SUBVERSION" = "x0" ]; then
165     LLVM_VERSION="$LLVM_SUBMIT_VERSION"
166 else
167     LLVM_VERSION="$LLVM_SUBMIT_VERSION-$LLVM_SUBMIT_SUBVERSION"
168 fi
169
170 GCC_VER=`cc --version 2>/dev/null | sed 1q`
171
172 if echo "$GCC_VER" | grep GCC > /dev/null; then
173     GCC_VER=`echo $GCC_VER | sed -e 's/.*(GCC) \([0-9.][0-9.]*\).*/\1/'`
174     MAJ_VER=`echo $GCC_VER | sed 's/\..*//'`
175     MIN_VER=`echo $GCC_VER | sed 's/[^.]*\.\([0-9]*\).*/\1/'`
176 fi
177
178 JOBS_FLAG=""
179
180 # Note: If compiling with GCC 4.0, don't pass the -jN flag. Building universal
181 # already has parallelism and we don't want to make the builders hit swap by
182 # firing off too many gccs at the same time.
183 if [ "x$MAJ_VER" != "x4" -o "x$MIN_VER" != "x0" ]; then
184     # Figure out how many make processes to run.
185     SYSCTL=`sysctl -n hw.activecpu`
186
187     # hw.activecpu only available in 10.2.6 and later
188     if [ -z "$SYSCTL" ]; then
189         SYSCTL=`sysctl -n hw.ncpu`
190     fi
191
192     # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot.
193     # Builders can default to 2, since even if they are single processor,
194     # nothing else is running on the machine.
195     if [ -z "$SYSCTL" ]; then
196         SYSCTL=2
197     fi
198
199     JOBS_FLAG="-j $SYSCTL"
200 fi
201
202 make $JOBS_FLAG $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$HOSTS" \
203     UNIVERSAL_SDK_PATH=$HOST_SDKROOT \
204     NO_RUNTIME_LIBS=1 \
205     DISABLE_EDIS=1 \
206     LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
207     LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
208     CXXFLAGS="-DLLVM_VERSION_INFO='\" Apple Build #$LLVM_VERSION\"'" \
209     VERBOSE=1
210
211 if [ $? != 0 ] ; then
212     echo "error: LLVM 'make' failed!"
213     exit 1
214 fi 
215
216 ################################################################################
217 # Construct the actual destination root, by copying stuff from $DIR/dst-* to
218 # $DEST_DIR, with occasional 'lipo' commands.
219
220 cd $DEST_DIR || exit 1
221
222 # Clean out DEST_DIR in case -noclean was passed to buildit.
223 rm -rf * || exit 1
224
225 cd $DIR/obj-llvm || exit 1
226
227 # Install the tree into the destination directory.
228 make $LOCAL_MAKEFLAGS $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$HOSTS" \
229     NO_RUNTIME_LIBS=1 \
230     DISABLE_EDIS=1 \
231     LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
232     LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
233     OPTIMIZE_OPTION='-O3' VERBOSE=1 install
234
235 if ! test $? == 0 ; then
236     echo "error: LLVM 'make install' failed!"
237     exit 1
238 fi 
239
240 # Install Version.h
241 LLVM_MINOR_VERSION=`echo $LLVM_SUBMIT_SUBVERSION | sed -e 's,0*\([1-9][0-9]*\),\1,'`
242 if [ "x$LLVM_MINOR_VERSION" = "x" ]; then
243     LLVM_MINOR_VERSION=0
244 fi
245 RC_ProjectSourceSubversion=`printf "%d" $LLVM_MINOR_VERSION`
246 echo "#define LLVM_VERSION ${RC_ProjectSourceVersion}" > $DEST_DIR$DEST_ROOT/include/llvm/Version.h
247 echo "#define LLVM_MINOR_VERSION ${RC_ProjectSourceSubversion}" >> $DEST_DIR$DEST_ROOT/include/llvm/Version.h
248
249 if [ "x$LLVM_DEBUG" != "x1" ]; then
250     # Strip local symbols from llvm libraries.
251     strip -S $DEST_DIR$DEST_ROOT/lib/*.[oa]
252     for f in `ls $DEST_DIR$DEST_ROOT/lib/*.so`; do
253         strip -Sx $f
254     done
255 fi
256
257 # Copy over the tblgen utility.
258 cp `find $DIR -name tblgen` $DT_HOME/local/bin
259
260 # Remove .dir files 
261 cd $DEST_DIR$DEST_ROOT
262 rm -f bin/.dir etc/llvm/.dir lib/.dir
263
264 # Remove PPC64 fat slices.
265 cd $DEST_DIR$DEST_ROOT/bin
266 if [ $MACOSX_DEPLOYMENT_TARGET = "10.4" ]; then
267     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
268         -exec lipo -extract ppc -extract i386 {} -output {} \;
269 elif [ $MACOSX_DEPLOYMENT_TARGET = "10.5" ]; then
270     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
271         -exec lipo -extract ppc7400 -extract i386 {} -output {} \;
272 else
273     find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
274         -exec lipo -extract ppc7400 -extract i386 -extract x86_64 {} -output {} \;
275 fi
276
277 cd $DEST_DIR$DEST_ROOT
278 if [ "$INSTALL_LIBLTO" == yes ]; then
279   mkdir -p $DT_HOME/lib
280   mv lib/libLTO.dylib $DT_HOME/lib/libLTO.dylib
281   strip -S $DT_HOME/lib/libLTO.dylib
282 fi
283 rm -f lib/libLTO.a lib/libLTO.la
284
285 # The Hello dylib is an example of how to build a pass. No need to install it.
286 rm lib/libLLVMHello.dylib
287
288 # Compress manpages
289 MDIR=$DEST_DIR$DEST_ROOT/share/man/man1
290 gzip -f $MDIR/*
291
292 ################################################################################
293 # Create SYM_DIR with information required for debugging.
294
295 # Figure out how many make processes to run.
296 SYSCTL=`sysctl -n hw.activecpu`
297
298 # hw.activecpu only available in 10.2.6 and later
299 if [ -z "$SYSCTL" ]; then
300   SYSCTL=`sysctl -n hw.ncpu`
301 fi
302
303 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot. Builders
304 # can default to 2, since even if they are single processor, nothing else is
305 # running on the machine.
306 if [ -z "$SYSCTL" ]; then
307   SYSCTL=2
308 fi
309
310 cd $SYM_DIR || exit 1
311
312 # Clean out SYM_DIR in case -noclean was passed to buildit.
313 rm -rf * || exit 1
314
315 # Generate .dSYM files
316 find $DEST_DIR -perm -0111 -type f \
317     ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config -o -name '*.a' \) \
318     -print | xargs -n 1 -P ${SYSCTL} dsymutil
319
320 # Save .dSYM files and .a archives
321 cd $DEST_DIR || exit 1
322 find . \( -path \*.dSYM/\* -or -name \*.a \) -print \
323     | cpio -pdml $SYM_DIR || exit 1
324
325 # Save source files.
326 mkdir $SYM_DIR/src || exit 1
327 cd $DIR || exit 1
328 find obj-* -name \*.\[chy\] -o -name \*.cpp -print \
329     | cpio -pdml $SYM_DIR/src || exit 1
330
331 ################################################################################
332 # Remove debugging information from DEST_DIR.
333
334 find $DEST_DIR -name \*.a -print | xargs ranlib || exit 1
335 find $DEST_DIR -name \*.dSYM -print | xargs rm -r || exit 1
336 chgrp -h -R wheel $DEST_DIR
337 chgrp -R wheel $DEST_DIR
338
339 ################################################################################
340 # Remove tar ball from docs directory
341
342 find $DEST_DIR -name html.tar.gz -exec rm {} \;
343
344 ################################################################################
345 # symlinks so that B&I can find things
346
347 if [ "$INSTALL_LIBLTO" == yes ]; then
348   mkdir -p $DEST_DIR/usr/lib/
349   cd $DEST_DIR/usr/lib && \
350     ln -s ../../$DEVELOPER_DIR/usr/lib/libLTO.dylib ./libLTO.dylib
351 fi
352
353 ################################################################################
354 # w00t! Done!
355
356 exit 0